$PORT=90001;

use IO::Socket;

$server = IO::Socket::INET->new(Proto => 'tcp',
	LocalPort => $PORT,
	Listen => SOMAXCONN,
	Reuse => 1) or die("Can't set up server");

system ("perl ./freewrl -eai localhost:90001 http://meson.dgrc.crc.ca/DIVE/EAISimple.wrl &");


$sock = $server->accept();
$sock->autoflush(1);

# print "jt6.pl EAI CLIENT STARITNG!!!!!\n";

sub getlines {
	# print "jt6.pl getlines starting\n";
	my @arr;
	for(1..$_[0]) {
		# print "jt6.pl EXPECTING ROW $_\n";
		my $str = <$sock>;
		chomp $str;
		# print "jt6.pl GOT '$str'\n";
		push @arr, $str;
	}
        print "jt6.pl returning from getlines @arr\n";
	return @arr;
}

# Test the sample EAI protocol.

$a = <$sock>;
$sock->print("TJL EAI CLIENT 0.02\n");

#---------------------


#---------------------

# make a cone for the avatar...
#$sock->print("4\nCVS Transform {translation -5.0 3.0 3.0 children [ Shape {geometry Cone{}}]}\nEOT\n");

#my @def = getlines(4);
#print "jt6.pl - CVS of cone returned @def\n\n\n\n\n\n\n";
##system ("sleep 2");

#---------------

# Step 1.Initial starting code.


system ("sleep 5");

#EAI input:1GN ROOTNODE
#EAI input:3GN VIEWPOINT
#EAI input:7GN BIGBOX
#EAI input:8GN VNET
print "jt6.pl starting step 1\n";

$sock->print("1\nGN ROOTNODE\n");
my @root = getlines(4);
print "\njt6.pl REAL node of ROOTNODE is $root[3]\n\n";

$sock->print("3\nGN VIEWPOINT\n");
my @view = getlines(4);
print "\njt6.pl REAL node of ROOTNODE is $view[3]\n\n";

$sock->print("7\nGN BIGBOX\n");
my @bb = getlines(4);
print "\njt6.pl REAL node of BIGBOX is $bb[3]\n\n";

$sock->print("8\nGN VNET\n");
my @vnet = getlines(4);
print "\njt6.pl REAL node of VNET is $vnet[3]\n\n";
#system ("sleep 2");


#--------------------------

# step 2. Register this listener, and turn lights on.
# note, we don't register, as this program has no way
# of handling EVents!!!!

#EAI input:16RL  BIGBOX  position_changed 16
#EAI input:17RL  BIGBOX  orientation_changed 17
#EAI input:21SE  VNET  isConnectedTRUE

print "jt6.pl starting step 2\n";
$sock->print("21\nSE $vnet[3] isConnected\nTRUE\n");

#system ("sleep 2"); 


# --------------------------

# step 3. Send in the first proto for the first avatar.
# this is the avatar for the externally connected user.
# (only simulate one user, for now!) Register listener
# for the avatar, but don't do it here...

#EAI input:22CVS PROTO ....
#EAI input:34RL  AVATAR_1  clicked 34
#EAI input:35RL  AVATAR_1  objectNodes 35

print "jt6.pl starting step 3\n";
# The "full" avatar...
$sock->print("22\nCVS PROTO Avatar [ exposedField SFVec3f position 0 5 0 ",
    "exposedField SFRotation orientation 0 0 0 0 exposedField SFVec3f scale ",
    "1.0 1.0 1.0 exposedField MFString name \"\" exposedField MFNode ",
    "objectNodes [] exposedField MFNode textNodes [] eventOut SFBool clicked ",
    "] { Transform { translation IS position rotation IS orientation children [ ",
#    "Shape { appearance Appearance { material Material {}} geometry Box {} }",
#    "Transform {translation -1.0 0.0 1.0 children [ Shape {geometry Box{}}]}",
    "Transform { rotation 0 1 0 3.14159 children [ Transform { translation ",
    "0.0 0.7 0.0 scale 0.2 0.2 0.2 children Billboard { children IS textNodes ",
    "} } Transform { scale IS scale children IS objectNodes } TouchSensor { ",
    "isActive IS clicked } ] } ] } } Avatar {} \nEOT\n");
#

my @proto1 = getlines(4);
print "jt6.pl - CVS of PROTO Avatar 1 returned @proto1\n";
#system ("sleep 2");

# --------------------------


# step 4. Now, parse the first avatar, add it to the proto, and set the position.
#EAI input:36CVU TinMan.wrl
#EAI input:38SE  AVATAR_1  objectNodes TINMAN_WRL 
#EAI input:39SE  AVATAR_1  position0.0 0.0 10.0
#EAI input:40SE  VIEWPOINT  set_bindFALSE
#EAI input:41SE  VIEWPOINT  position0.0 0.0 10.0
#EAI input:42SE  VIEWPOINT  set_bindTRUE
#EAI input:43SE  AVATAR_1  position0.0 0.0 -0.10000001

print "jt6.pl starting step 4\n";
$sock->print("36\nCVU http://meson.dgrc.crc.ca/DIVE/avatars/TinMan.wrl\n");
my @tinman1 = getlines(4);
print "jt6.pl tinman is @tinman1\n";

$sock->print("38\nSE $proto1[3] objectNodes\n$tinman1[3]\n");
#my @x = getlines(3);

$sock->print("39\nSE $proto1[3] position\n0.0 0.0 10.0\n");
#my @x = getlines(3);

#$sock->print("40\nSE $view[3] set_bind\nFALSE\n");
##my @x = getlines(3);

#$sock->print("41\nSE $view[3] position\n0.0 0.0 13.0\n");
#my @x = getlines(3);

#$sock->print("42\nSE $view[3] set_bind\nTRUE\n");
#my @x = getlines(3);

$sock->print("43\nSE $proto1[3] position\n0.0 0.0 -0.10000001\n");
#my @x = getlines(3);

# --------------------------

# step 5.  Make the second avatar, and add it to the root node.
# forget the register listeners, again...
# 
#EAI input:44CVS PROTO Avatar ....
#EAI input:45SE  AVATAR_1  position0.0 0.0 9.9
#EAI input:57RL  AVATAR_2  clicked 57
#EAI input:58SE  ROOTNODE  addChildren AVATAR_2 


print "jt6.pl starting step 5\n";
# The "full" avatar...
$sock->print("44\nCVS PROTO Avatar [ exposedField SFVec3f position 0 0 0 ",
    "exposedField SFRotation orientation 0 0 0 0 exposedField SFVec3f scale ",
    "1.0 1.0 1.0 exposedField MFString name \"\" exposedField MFNode ",
    "objectNodes [] exposedField MFNode textNodes [] eventOut SFBool clicked ",
    "] { Transform { translation IS position rotation IS orientation children [ ",
#    "Shape { appearance Appearance { material Material {}} geometry Cone {} }",
#    "Transform {translation -1.0 0.0 1.0 children [ Shape {geometry Box{}}]}",
    "Transform { rotation 0 1 0 3.14159 children [ Transform { translation ",
    "0.0 0.7 0.0 scale 0.2 0.2 0.2 children Billboard { children IS textNodes ",
    "} } Transform { scale IS scale children IS objectNodes } TouchSensor { ",
    "isActive IS clicked } ] } ] } } Avatar {} \nEOT\n");
#

my @proto2 = getlines(4);
print "jt6.pl - CVS of PROTO Avatar 2 returned @proto2\n";

$sock->print("45\nSE $proto1[3] position\n0.0 0.0 15.9\n");
#my @x = getlines(3);

$sock->print("58\nSE $root[3] addChildren\n$proto2[3]\n");
#my @x = getlines(4);


#system ("sleep 2");


# ----------------------

# step 6. Get the second avatar up and running here.

print "jt6.pl starting step 6\n";


#EAI input:59RL  AVATAR_2  objectNodes 59
#EAI input:60CVU emu2.wrl
#EAI input:62SE  AVATAR_2  objectNodes EMU2_WRL 
#EAI input:63SE  AVATAR_1  orientation0.0 0.0 1.0 0.0
#EAI input:64SE  VIEWPOINT  set_bindFALSE
#EAI input:65SE  VIEWPOINT  orientation0.0 0.0 1.0 0.0
#EAI input:66SE  VIEWPOINT  set_bindTRUE
#EAI input:67SE  AVATAR_1  position0.0 0.0 -0.10000001
#EAI input:68SE  AVATAR_1  scale1.0 1.0 1.0
#EAI input:69SE  AVATAR_1  position0.0 0.0 9.9


$sock->print("60\nCVU http://meson.dgrc.crc.ca/DIVE/avatars/TinMan.wrl\n");
my @emu2 = getlines(4);
print "jt6.pl tinman is @emu2\n";

$sock->print("62\nSE $proto2[3] objectNodes\n$emu2[3]\n");
#my @x = getlines(3);
print "\n\n\njt6.pl - now the avatar should be there in the proto.\n\n\n";
system ("sleep 20");

# ----------------------

# step 7. add names to protos..

print "jt6.pl starting step 7\n";


#EAI input:70SE  AVATAR_1  name"me at linux"
#EAI input:71CVS Shape {   geometry Text {     string "me at linux"     fontStyle FontStyle {       justify  "MIDDLE"       family   "SANS"     }   } } 
#EAI input:72SE  AVATAR_1  textNodes AVATAR2_TEXT 
#EAI input:73SE  AVATAR_2  position0.092802554 4.4703476E-9 10.226776
#EAI input:74SE  AVATAR_2  orientation0.0 0.9999999 0.0 0.2061158
#EAI input:75SE  AVATAR_2  scale1.0 1.0 1.0
#EAI input:76SE  AVATAR_2  name"me at nt"
#EAI input:77CVS Shape {   geometry Text {     string "me at nt"     fontStyle FontStyle {       justify  "MIDDLE"       family   "SANS"     }   } } 
#EAI input:78SE  AVATAR_2  textNodes AVATAR1_TEXT

$sock->print("70\nSE $proto1[3] name\n\"me at linux\"\n");
#my @x = getlines(3);

$sock->print("71\nCVS Shape {geometry Text{ string \"me at linux\" fontStyle FontStyle",
       " {justify \"MIDDLE\" family \"SANS\"}}}\nEOT\n"); 
my @meatlinux = getlines(4);
print "jt6.pl C VS returned @meatlinux\n";

$sock->print("72\nSE $proto1[3] textNodes\n$meatlinux[3]\n");
#my @x = getlines(3);

$sock->print("73\nSE $proto2[3] position\n0.092802554 4.4703476E-9 10.226776\n");
#my @x = getlines(3);

$sock->print("74\nSE $proto2[3] orientation\n0.0 0.9999999 0.0 0.2061158\n");
#my @x = getlines(3);

$sock->print("75\nSE $proto2[3] scale\n1.0 1.0 1.0\n");
#my @x = getlines(3);

$sock->print("76\nSE $proto2[3] name\n\"me at nt\"\n");
#my @x = getlines(3);

$sock->print("77\nCVS Shape {geometry Text{ string \"me at nt\" fontStyle FontStyle",
       " {justify \"MIDDLE\" family \"SANS\"}}}\nEOT\n"); 
my @meatnt = getlines(4);
print "jt6.pl CVS returned @meatnt\n";


$sock->print("78\nSE $proto2[3] textNodes\n$meatnt[3]\n");
#my @x = getlines(3);

print "\n\n\njt6.pl - now, the name me at nt should be there \n\n\n";
system ("sleep 20");
# ----------------------

# step 8. add me -simulate an OOBE

print "jt6.pl starting step 8\n";
#EAI input:99SE  ROOTNODE  addChildren AVATAR_1 
$sock->print("99\nSE $root[3] addChildren\n$proto1[3]\n");
#my @x = getlines(4);
system("sleep 2");

$sock->print("200\nSE $proto2[3] position\n0.0 0.0 9.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 8.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 7.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 6.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 5.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 4.0\n");
system ("sleep 1");
$sock->print("200\nSE $proto2[3] position\n0.0 0.0 3.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 9.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 8.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 7.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 6.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 5.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 4.0\n");
system ("sleep 1");
$sock->print("300\nSE $proto1[3] position\n6.0 0.0 3.0\n");
